/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// id1 - The unique ID of the call to transfer from.    id2 - The unique ID of the call to transfer to.    timeout - The time in milliseconds to wait for the completion of the transfer.
    /// </summary>
    [DataContract]
        public partial class AttendedTransferParams :  IEquatable<AttendedTransferParams>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="AttendedTransferParams" /> class.
        /// </summary>
        /// <param name="id1">id1.</param>
        /// <param name="id2">id2.</param>
        /// <param name="sipHeaders">sipHeaders.</param>
        /// <param name="timeout">timeout.</param>
        public AttendedTransferParams(string id1 = default(string), string id2 = default(string), List<string> sipHeaders = default(List<string>), int? timeout = default(int?))
        {
            this.Id1 = id1;
            this.Id2 = id2;
            this.SipHeaders = sipHeaders;
            this.Timeout = timeout;
        }
        
        /// <summary>
        /// Gets or Sets Id1
        /// </summary>
        [DataMember(Name="id1", EmitDefaultValue=false)]
        public string Id1 { get; set; }

        /// <summary>
        /// Gets or Sets Id2
        /// </summary>
        [DataMember(Name="id2", EmitDefaultValue=false)]
        public string Id2 { get; set; }

        /// <summary>
        /// Gets or Sets SipHeaders
        /// </summary>
        [DataMember(Name="sipHeaders", EmitDefaultValue=false)]
        public List<string> SipHeaders { get; set; }

        /// <summary>
        /// Gets or Sets Timeout
        /// </summary>
        [DataMember(Name="timeout", EmitDefaultValue=false)]
        public int? Timeout { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class AttendedTransferParams {\n");
            sb.Append("  Id1: ").Append(Id1).Append("\n");
            sb.Append("  Id2: ").Append(Id2).Append("\n");
            sb.Append("  SipHeaders: ").Append(SipHeaders).Append("\n");
            sb.Append("  Timeout: ").Append(Timeout).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as AttendedTransferParams);
        }

        /// <summary>
        /// Returns true if AttendedTransferParams instances are equal
        /// </summary>
        /// <param name="input">Instance of AttendedTransferParams to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(AttendedTransferParams input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id1 == input.Id1 ||
                    (this.Id1 != null &&
                    this.Id1.Equals(input.Id1))
                ) && 
                (
                    this.Id2 == input.Id2 ||
                    (this.Id2 != null &&
                    this.Id2.Equals(input.Id2))
                ) && 
                (
                    this.SipHeaders == input.SipHeaders ||
                    this.SipHeaders != null &&
                    input.SipHeaders != null &&
                    this.SipHeaders.SequenceEqual(input.SipHeaders)
                ) && 
                (
                    this.Timeout == input.Timeout ||
                    (this.Timeout != null &&
                    this.Timeout.Equals(input.Timeout))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id1 != null)
                    hashCode = hashCode * 59 + this.Id1.GetHashCode();
                if (this.Id2 != null)
                    hashCode = hashCode * 59 + this.Id2.GetHashCode();
                if (this.SipHeaders != null)
                    hashCode = hashCode * 59 + this.SipHeaders.GetHashCode();
                if (this.Timeout != null)
                    hashCode = hashCode * 59 + this.Timeout.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
